"""
summary_file.py

This module contains the SummaryFile class, which is used to provide a basic overview of the
checks performed per overall as well as per file.
- Types of Checks Performed
- Types of Checks Passed
- Types of Checks Failed
- Number of Checks Performed
- Number of Checks Passed
- Number of Checks Failed
"""

from collections import Counter
import json
import re

from frictionless import Checklist

from ..objects.quality_issues import scope


# regex pattern for extracting the failing check code from a test case ID
ID_EXTRACT_PATTERN = r"(schema_violation|data_quality)_([\w-]+)_.*"

# List of checks to ignore. "passed" are checks that are not actually failures, and the others are
# checks not relevant to this project
IGNORED_CHECKS = ["passed", "primary-key", "foreign-key"]


def find_all_failing_checks(results: dict):
    """
    Analyzes the results of data validation checks and identifies all failing checks.
    Args:
        results (dict): A dictionary containing the results of data validation checks.

    Returns:
        dict: A dictionary where the keys are file paths and the values are lists of failing checks
            for each file. Additionally, includes an "overall" key that contains a dictionary
            tallying the total number of occurrences of each failing check across all files.
    """
    failing_checks_by_file = {}

    # Iterate over all of the files in the results and tally the failing checks for each
    for data_file in results[0]["data_files"]:
        filepath = data_file["filepath"]
        file_failing_checks = find_failing_checks_in_file(data_file)

        failing_checks_by_file[filepath] = file_failing_checks

    return failing_checks_by_file


def find_failing_checks_in_file(file_results: dict):
    """
    Identifies and returns a list of failing checks from the provided file results.
    Args:
        file_results (dict): A dictionary containing the results of validation and quality test
            cases.

    Returns:
        list: A list of failing check codes extracted from the test case IDs.
    """
    validation_testcases = file_results["validation_testcases"]
    quality_testcases = file_results["quality_testcases"]

    failing_checks = set()

    for testcase in validation_testcases + quality_testcases:
        testcase_id = testcase["id"]

        testcase_code_match = re.search(ID_EXTRACT_PATTERN, testcase_id)
        if testcase_code_match:
            testcase_code = testcase_code_match.group(2)

            if testcase_code in IGNORED_CHECKS:
                continue

            failing_checks.add(testcase_code)

    return list(failing_checks)


class SummaryFile:
    """
    Represents a summary file that provides a basic overview of the checks performed per overall as
    well as per file. Relies on the results.json file generated by the main script.

    Attributes:
        results (dict): A dictionary containing the results of data validation checks.

    Methods:
        from_file (classmethod): Loads a SummaryFile from a file.
        all_checks: Returns a list of all checks performed.
        failing_checks_by_file: Returns a dictionary of failing checks by file.
        failing_checks_by_type: Returns a dictionary of failing checks by type.
        failing_checks: Returns a list of all failing checks.
        passing_checks: Returns a list of all passing checks.
        num_total_checks: Returns the total number of checks performed.
        num_failing_checks: Returns the number of failing checks.
        num_passing_checks: Returns the number of passing checks.
        num_files_checked: Returns the number of files checked.
        num_files_failed: Returns the number of files that failed checks.
        num_files_passed: Returns the number of files that passed checks.
        as_dict: Returns the summary file as a dictionary.
        to_file: Writes the summary file to disk as a JSON file.
    """

    @classmethod
    def from_file(cls, file_path: str):
        """
        Class method to load a StoplightFile from a file.
        """
        with open(file_path, "r", encoding="utf-8") as file:
            return cls(json.load(file))

    @property
    def all_checks(self):
        """Returns a list of all checks performed."""
        checklist = Checklist()
        frictionless_checks = checklist.scope
        quality_checks = scope

        all_checks = frictionless_checks + quality_checks

        # Remove ignored checks
        return [check for check in all_checks if check not in IGNORED_CHECKS]

    @property
    def failing_checks_by_file(self):
        """Returns a dictionary of failing checks by file."""
        return find_all_failing_checks(self.results)

    @property
    def failing_checks_by_type(self):
        """Returns a dictionary of failing checks by type."""
        my_counter = Counter()
        for _, checks_failed in self.failing_checks_by_file.items():
            for check in checks_failed:
                my_counter[check] += 1

        return dict(my_counter)

    @property
    def failing_checks(self):
        """Returns a list of all failing checks."""
        all_failing_checks = (
            check for checks in self.failing_checks_by_file.values() for check in checks)

        return list(set(all_failing_checks))

    @property
    def passing_checks(self):
        """Returns a list of all passing checks."""
        return [check for check in self.all_checks if check not in self.failing_checks]

    @property
    def num_total_checks(self):
        """Returns the total number of checks performed."""
        return len(self.all_checks)

    @property
    def num_failing_checks(self):
        """Returns the number of failing checks."""
        return len(self.failing_checks)

    @property
    def num_passing_checks(self):
        """Returns the number of passing checks."""
        return len(self.passing_checks)

    @property
    def num_files_checked(self):
        """Returns the number of files checked."""
        return len(self.failing_checks_by_file)

    @property
    def num_files_failed(self):
        """Returns the number of files that failed checks."""
        return len([file for file, checks in self.failing_checks_by_file.items() if checks])

    @property
    def num_files_passed(self):
        """Returns the number of files that passed checks."""
        return len([file for file, checks in self.failing_checks_by_file.items() if not checks])

    def __init__(self, results: dict):
        self.results = results

    def as_dict(self):
        """
        Returns the summary file as a dictionary.
        """
        return {
            "checks_performed": {
                "all_checks": self.all_checks,
                "failing_checks": self.failing_checks,
                "passing_checks": self.passing_checks,
            },
            "check_counts": {
                "num_total_checks": self.num_total_checks,
                "num_failing_checks": self.num_failing_checks,
                "num_passing_checks": self.num_passing_checks,
                "by_type": self.failing_checks_by_type,
                "num_files_checked": self.num_files_checked,
                "num_files_failed": self.num_files_failed,
                "num_files_passed": self.num_files_passed,
            }
        }

    def to_file(self, filepath):
        """
        Writes the summary file to disk as a JSON file.
        Args:
            filepath (str): The path to write the summary file to.
        """
        with open(filepath, "w", encoding="utf-8") as file_obj:
            json.dump(self.as_dict(), file_obj, indent=4)
